--- debian/initramfs/cryptroot-hook	(revision 883)
+++ debian/initramfs/cryptroot-hook	(working copy)
@@ -407,6 +407,10 @@
 				copy_exec "/lib/cryptsetup/scripts/$KEYSCRIPT" /lib/cryptsetup/scripts >&2
 			elif [ -e "$KEYSCRIPT" ]; then
 				copy_exec "$KEYSCRIPT" /lib/cryptsetup/scripts >&2
+			elif KSTYPE="$(type "$KEYSCRIPT" 2>&1)"; then
+				if [ -x "${KSTYPE#"$KEYSCRIPT" is }" ]; then
+					copy_exec "${KSTYPE#"$KEYSCRIPT" is }" /lib/cryptsetup/scripts >&2
+				fi
 			else
 				echo "cryptsetup: WARNING: failed to find keyscript $KEYSCRIPT" >&2
 				continue
===================================================================
--- debian/initramfs/cryptroot-script	(revision 883)
+++ debian/initramfs/cryptroot-script	(working copy)
@@ -184,7 +184,7 @@
 
 	parse_options "$opts" || return 1
 
-	if [ -n "$cryptkeyscript" ] && [ ! -x "$cryptkeyscript" ]; then
+	if [ -n "$cryptkeyscript" ] && ! type "$cryptkeyscript" >/dev/null; then
 		message "cryptsetup: error - script \"$cryptkeyscript\" missing"
 		return 1
 	fi
--- debian/cryptdisks.functions	(revision 883)
+++ debian/cryptdisks.functions	(working copy)
@@ -167,11 +167,12 @@
 			elif [ -z "$VALUE" ]; then
 				log_warning_msg "$dst: no value for keyscript option, skipping"
 				return 1
-			#elif type "$VALUE" >/dev/null 2>&1; then
 			elif [ -x "$VALUE" ]; then
 				KEYSCRIPT="$VALUE"
 			elif [ -x "/lib/cryptsetup/scripts/$VALUE" ]; then
 				KEYSCRIPT="/lib/cryptsetup/scripts/$VALUE"
+			elif type "$VALUE" >/dev/null 2>&1; then
+				KEYSCRIPT="$VALUE"
 			else
 				log_warning_msg "script $VALUE is not an executable script, skipping"
 				return 1
